match := function(o,a,b) 
  return a[1+o] = - b[1+((o+2) mod 4)];
end;

rotate := function(o,x,t)
  local a,b,c,d,u;
  a:=t[1]; b:=t[2]; c:=t[3]; d:=t[4];
  if match(o,x,t) then return t; fi;
  u:=[b,c,d,a];
  if match(o,x,u) then return u; fi;
  u:=[c,d,a,b];
  if match(o,x,u) then return u; fi;
  u:=[d,a,b,c];
  if match(o,x,u) then return u; fi;
  return false;
end;

rcheck := function (p)
 local n,e,s,w,
       p11,p12,p13,p21,p22,p23,p31,p32,p33,
       p22r,p12r,p32r,p21r,p23r,p11r,p13r,p31r,p33r;
 n:=0; e:=1; s:=2; w:=3;
 p11:=p[1]; p12:=p[2]; p13:=p[3];
 p21:=p[4]; p22:=p[5]; p23:=p[6];
 p31:=p[7]; p32:=p[8]; p33:=p[9];
 p22r := p22;
 p12r := rotate(n, p22r, p12); if p12r=false then return false; fi;
 p32r := rotate(s, p22r, p32); if p32r=false then return false; fi;
 p21r := rotate(w, p22r, p21); if p21r=false then return false; fi;
 p23r := rotate(e, p22r, p23); if p23r=false then return false; fi;
 p11r := rotate(w, p12r, p11);
 if p11r=false or not match(n,p21r,p11r) then return false; fi;
 p13r := rotate(e, p12r, p13);
 if p13r=false or not match(n,p23r,p13r) then return false; fi;
 p31r := rotate(w, p32r, p31);
 if p31r=false or not match(s,p21r,p31r) then return false; fi;
 p33r := rotate(e, p32r, p33);
 if p33r=false or not match(s,p23r,p33r) then return false; fi;
 return true;
 Concatenation([p12r,p21r,p11r,p23r,p13r,p32r,p31r,p33r]);
end;

catp := function()
  local pinkT, blueT, redT, purpleT,
        pinkH, blueH, redH, purpleH, tiles;
  pinkT:=1;  blueT:=2;  redT:=3;  purpleT:=4;
  pinkH:=-1; blueH:=-2; redH:=-3; purpleH:=-4;
  tiles :=   
        [ [pinkT, blueT,   redH,    purpleH],
          [pinkT, purpleH, redH,    blueT],
          [pinkT, redT,    purpleH, blueH],
          [pinkT, redH,    blueH,   redT],
          [pinkT, redH,    blueH,   purpleT],
          [pinkH, redT,    blueT,   purpleH],
          [pinkH, redT,    blueT,   purpleH],
          [pinkH, purpleT, blueT,   redH],
          [pinkH, purpleT, blueT,   purpleH] ];
  return List(Filtered(AsList(SymmetricGroup(9)),p->rcheck(Permuted(tiles,p))<>false),p->Permuted([0..8],p));
end;
